/*=========================================================================
UberSim Source Code Release
-------------------------------------------------------------------------
Copyright (C) 2002 Manuela Veloso, Brett Browning, Mike Bowling,
                   James Bruce; {mmv, brettb, mhb, jbruce}@cs.cmu.edu
                   Erick Tryzelaar {erickt}@andrew.cmu.edu
School of Computer Science, Carnegie Mellon University
-------------------------------------------------------------------------
This software is distributed under the GNU General Public License,
version 2.  If you do not have a copy of this licence, visit
www.gnu.org, or write: Free Software Foundation, 59 Temple Place,
Suite 330 Boston, MA 02111-1307 USA.  This program is distributed
in the hope that it will be useful, but WITHOUT ANY WARRANTY,
including MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-------------------------------------------------------------------------*/

#ifndef __SIM_SLIDERJOINT_H__
#define __SIM_SLIDERJOINT_H__

#include "Joint.h"
#include "Vector3.h"

class RigidBody;

class SliderJoint : public Joint
{
	public:
		SliderJoint          (RigidBody* rigidBody1, RigidBody* RigidBody2);
		virtual ~SliderJoint ();

	public:
		void set (char* name, char* value);

		void setAxis           (const Vector3& axis);
		void setLimits         (const Real     lowLimit, const Real highLimit);
		void setMaxForce       (const Real     maxFoce);
		void setTargetVelocity (const Real     velocity);

};

#endif
